net.minecraft.entity

## Class Entity

- java.lang.Object
- - net.minecraft.entity.Entity

- Direct Known Subclasses:
    EntityArrow, EntityBoat, EntityDragonPart, EntityEnderCrystal, EntityEnderEye, EntityFallingSand, EntityFireball, EntityFireworkRocket, EntityFishHook, EntityFX, EntityHanging, EntityItem, EntityLivingBase, EntityMinecart, EntityThrowable, EntityTNTPrimed, EntityWeatherEffect, EntityXPOrb

      public abstract class Entity
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `boolean` | `addedToChunk` Has this entity been added to the chunk its within
    `AxisAlignedBB` | `boundingBox` Axis aligned bounding box.
    `ArrayList<EntityItem>` | `capturedDrops`
    `boolean` | `captureDrops`
    `int` | `chunkCoordX`
    `int` | `chunkCoordY`
    `int` | `chunkCoordZ`
    `int` | `dimension` Which dimension the player is in (-1 = the Nether, 0 = normal world)
    `float` | `distanceWalkedModified` The distance walked multiplied by 0.6
    `float` | `distanceWalkedOnStepModified`
    `float` | `entityCollisionReduction` Reduces the velocity applied by entity collisions by the specified percent.
    `int` | `entityId`
    `float` | `fallDistance`
    `boolean` | `field_70135_K`
    `int` | `fireResistance` The amount of ticks you have to stand inside of fire before be set on fire
    `boolean` | `forceSpawn`
    `float` | `height` How high this entity is considered to be
    `int` | `hurtResistantTime` Remaining time an entity will be "immune" to further damage after being hurt.
    `boolean` | `ignoreFrustumCheck` Render entity even if it is outside the camera frustum.
    `boolean` | `isAirBorne`
    `boolean` | `isCollided` True if after a move this entity has collided with something either vertically or horizontally
    `boolean` | `isCollidedHorizontally` True if after a move this entity has collided with something on X- or Z-axis
    `boolean` | `isCollidedVertically` True if after a move this entity has collided with something on Y-axis
    `boolean` | `isDead` Gets set by setDead, so this must be the flag whether an Entity is dead (inactive may be better term)
    `double` | `lastTickPosX` The entity's X coordinate at the previous tick, used to calculate position during rendering routines
    `double` | `lastTickPosY` The entity's Y coordinate at the previous tick, used to calculate position during rendering routines
    `double` | `lastTickPosZ` The entity's Z coordinate at the previous tick, used to calculate position during rendering routines
    `double` | `motionX` Entity motion X
    `double` | `motionY` Entity motion Y
    `double` | `motionZ` Entity motion Z
    `EnumEntitySize` | `myEntitySize`
    `boolean` | `noClip` Whether this entity won't clip with collision or not (make note it won't disable gravity)
    `boolean` | `onGround`
    `double` | `posX` Entity position X
    `double` | `posY` Entity position Y
    `double` | `posZ` Entity position Z
    `float` | `prevDistanceWalkedModified` The previous ticks distance walked multiplied by 0.6
    `boolean` | `preventEntitySpawning` Blocks entities from spawning when they do their AABB check to make sure the spot is clear of entities that can prevent spawning.
    `double` | `prevPosX`
    `double` | `prevPosY`
    `double` | `prevPosZ`
    `float` | `prevRotationPitch`
    `float` | `prevRotationYaw`
    `double` | `renderDistanceWeight`
    `Entity` | `riddenByEntity` The entity that is riding this entity
    `Entity` | `ridingEntity` The entity we are currently riding
    `float` | `rotationPitch` Entity rotation Pitch
    `float` | `rotationYaw` Entity rotation Yaw
    `int` | `serverPosX`
    `int` | `serverPosY`
    `int` | `serverPosZ`
    `float` | `stepHeight` How high this entity can step up when running into a block to try to get over it (currently make note the entity will always step up this amount and not just the amount needed)
    `int` | `ticksExisted` How many ticks has this entity had ran since being alive
    `int` | `timeUntilPortal`
    `boolean` | `velocityChanged`
    `float` | `width` How wide this entity is considered to be
    `World` | `worldObj` Reference to the World object.
    `float` | `yOffset`
    `float` | `ySize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Entity(World par1World)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addEntityCrashInfo(CrashReportCategory par1CrashReportCategory)`
    `void` | `addToPlayerScore(Entity par1Entity, int par2)` Adds a value to the player score.
    `void` | `addVelocity(double par1, double par3, double par5)` Adds to the current velocity of the entity.
    `void` | `applyEntityCollision(Entity par1Entity)` Applies a velocity to each of the entities pushing them away from each other.
    `boolean` | `attackEntityFrom(DamageSource par1DamageSource, float par2)` Called when the entity is attacked.
    `boolean` | `canAttackWithItem()` If returns false, the item will not inflict any damage against entities.
    `boolean` | `canBeCollidedWith()` Returns true if other Entities should be prevented from moving through this Entity.
    `boolean` | `canBePushed()` Returns true if this entity should push and be pushed by other entities when colliding.
    `boolean` | `canRenderOnFire()`
    `boolean` | `canRiderInteract()` If a rider of this entity can interact with this entity.
    `void` | `copyDataFrom(Entity par1Entity, boolean par2)` Copies important data from another entity to this entity.
    `void` | `copyLocationAndAnglesFrom(Entity par1Entity)` Sets this entity's location and angles to the location and angles of the passed in entity.
    `boolean` | `doesEntityNotTriggerPressurePlate()` Return whether this entity should NOT trigger a pressure plate or a tripwire.
    `EntityItem` | `dropItem(int par1, int par2)` Drops an item stack at the entity's position.
    `EntityItem` | `dropItemWithOffset(int par1, int par2, float par3)` Drops an item stack with a specified y offset.
    `EntityItem` | `entityDropItem(ItemStack par1ItemStack, float par2)` Drops an item at the position of the entity.
    `boolean` | `equals(Object par1Obj)`
    `void` | `extinguish()` Removes fire from entity.
    `int` | `getAir()`
    `float` | `getBlockExplosionResistance(Explosion par1Explosion, World par2World, int par3, int par4, int par5, Block par6Block)` Gets a block's resistance to this entity's explosion.
    `AxisAlignedBB` | `getBoundingBox()` returns the bounding box for this entity
    `float` | `getBrightness(float par1)` Gets how bright this entity is.
    `int` | `getBrightnessForRender(float par1)`
    `float` | `getCollisionBorderSize()`
    `AxisAlignedBB` | `getCollisionBox(Entity par1Entity)` Returns a boundingBox used to collide the entity with other entities and blocks.
    `DataWatcher` | `getDataWatcher()`
    `double` | `getDistance(double par1, double par3, double par5)` Gets the distance to the position.
    `double` | `getDistanceSq(double par1, double par3, double par5)` Gets the squared distance to the position.
    `double` | `getDistanceSqToEntity(Entity par1Entity)` Returns the squared distance to the entity.
    `float` | `getDistanceToEntity(Entity par1Entity)` Returns the distance to the entity.
    `NBTTagCompound` | `getEntityData()` Returns a NBTTagCompound that can be used to store custom data for this entity.
    `String` | `getEntityName()` Gets the username of the entity.
    `IExtendedEntityProperties` | `getExtendedProperties(String identifier)` Gets the extended properties identified by the passed in key
    `float` | `getEyeHeight()`
    `ItemStack[]` | `getLastActiveItems()`
    `Vec3` | `getLookVec()` returns a (normalized) vector of where this entity is looking
    `int` | `getMaxInPortalTime()` Return the amount of time this entity should stay in a portal before being transported.
    `int` | `getMaxSafePointTries()` The number of iterations PathFinder.getSafePoint will execute before giving up.
    `double` | `getMountedYOffset()` Returns the Y offset from the entity's position for any entity riding this one.
    `Entity[]` | `getParts()` Return the Entity parts making up this Entity (currently only for dragons)
    `UUID` | `getPersistentID()`
    `ItemStack` | `getPickedResult(MovingObjectPosition target)` Called when a user uses the creative pick block button on this entity.
    `int` | `getPortalCooldown()` Return the amount of cooldown before this entity can use a portal again.
    `float` | `getRotationYawHead()`
    `float` | `getShadowSize()`
    `int` | `getTeleportDirection()`
    `String` | `getTranslatedEntityName()` Returns the translated name of the entity.
    `UUID` | `getUniqueID()`
    `double` | `getYOffset()` Returns the Y Offset of this entity.
    `void` | `handleHealthUpdate(byte par1)`
    `boolean` | `handleLavaMovement()` Whether or not the current entity is in lava
    `boolean` | `handleWaterMovement()` Returns if this entity is in water and will end up adding the waters velocity to the entity
    `int` | `hashCode()`
    `boolean` | `hitByEntity(Entity par1Entity)` Called when a player attacks an entity.
    `boolean` | `interactFirst(EntityPlayer par1EntityPlayer)` First layer of player interaction
    `boolean` | `isBurning()` Returns true if the entity is on fire.
    `boolean` | `isCreatureType(EnumCreatureType type, boolean forSpawnCount)` Returns true if the entity is of the @link{EnumCreatureType} provided
    `boolean` | `isEating()`
    `boolean` | `isEntityAlive()` Checks whether target entity is alive.
    `boolean` | `isEntityEqual(Entity par1Entity)` Returns true if Entity argument is equal to this Entity
    `boolean` | `isEntityInsideOpaqueBlock()` Checks if this entity is inside of an opaque block
    `boolean` | `isEntityInvulnerable()` Return whether this entity is invulnerable to damage.
    `boolean` | `isImmuneToFire()`
    `boolean` | `isInRangeToRenderDist(double par1)`
    `boolean` | `isInRangeToRenderVec3D(Vec3 par1Vec3)`
    `boolean` | `isInsideOfMaterial(Material par1Material)` Checks if the current block the entity is within of the specified material type
    `boolean` | `isInvisible()`
    `boolean` | `isInvisibleToPlayer(EntityPlayer par1EntityPlayer)`
    `boolean` | `isInWater()` Checks if this entity is inside water (if inWater field is true as a result of handleWaterMovement() returning true)
    `boolean` | `isOffsetPositionInLiquid(double par1, double par3, double par5)` Checks if the offset position from the entity's current position is inside of liquid.
    `boolean` | `isPushedByWater()`
    `boolean` | `isRiding()` Returns true if the entity is riding another entity, used by render to rotate the legs to be in 'sit' position for players.
    `boolean` | `isSneaking()` Returns if this entity is sneaking.
    `boolean` | `isSprinting()` Get if the Entity is sprinting.
    `boolean` | `isWet()` Checks if this entity is either in water or on an open air block in rain (used in wolves).
    `void` | `mountEntity(Entity par1Entity)` Called when a player mounts an entity.
    `void` | `moveEntity(double par1, double par3, double par5)` Tries to moves the entity by the passed in displacement.
    `void` | `moveFlying(float par1, float par2, float par3)` Used in both water and by flying objects
    `void` | `onChunkLoad()`
    `void` | `onCollideWithPlayer(EntityPlayer par1EntityPlayer)` Called by a player entity when they collide with an entity
    `void` | `onEntityUpdate()` Gets called every tick from main Entity class
    `void` | `onKillEntity(EntityLivingBase par1EntityLivingBase)` This method gets called when the entity kills another one.
    `void` | `onStruckByLightning(EntityLightningBolt par1EntityLightningBolt)` Called when a lightning bolt hits the entity.
    `void` | `onUpdate()` Called to update the entity's position/logic.
    `void` | `performHurtAnimation()`
    `void` | `playSound(String par1Str, float par2, float par3)`
    `void` | `readFromNBT(NBTTagCompound par1NBTTagCompound)` Reads the entity from NBT (calls an abstract helper method to read specialized data)
    `String` | `registerExtendedProperties(String identifier, IExtendedEntityProperties properties)` Register the instance of IExtendedProperties into the entity's collection.
    `void` | `resetEntityId()` Reset the entity ID to a new value.
    `void` | `setAir(int par1)`
    `void` | `setAngles(float par1, float par2)`
    `void` | `setCurrentItemOrArmor(int par1, ItemStack par2ItemStack)` Sets the held item, or an armor slot.
    `void` | `setDead()` Will get destroyed next tick.
    `void` | `setEating(boolean par1)`
    `void` | `setFire(int par1)` Sets entity to burn for x amount of seconds, cannot lower amount of existing fire.
    `void` | `setInPortal()` Called by portal blocks when an entity is within it.
    `void` | `setInvisible(boolean par1)`
    `void` | `setInWeb()` Sets the Entity inside a web block.
    `void` | `setLocationAndAngles(double par1, double par3, double par5, float par7, float par8)` Sets the location and Yaw/Pitch of an entity in the world
    `void` | `setPosition(double par1, double par3, double par5)` Sets the x,y,z of the entity from the given parameters.
    `void` | `setPositionAndRotation(double par1, double par3, double par5, float par7, float par8)` Sets the entity's position and rotation.
    `void` | `setPositionAndRotation2(double par1, double par3, double par5, float par7, float par8, int par9)`
    `void` | `setRotationYawHead(float par1)`
    `void` | `setSneaking(boolean par1)` Sets the sneaking flag.
    `void` | `setSprinting(boolean par1)` Set sprinting switch for Entity.
    `void` | `setVelocity(double par1, double par3, double par5)`
    `void` | `setWorld(World par1World)` Sets the reference to the World object.
    `boolean` | `shouldDismountInWater(Entity rider)` If the rider should be dismounted from the entity when the entity goes under water
    `boolean` | `shouldExplodeBlock(Explosion par1Explosion, World par2World, int par3, int par4, int par5, int par6, float par7)`
    `boolean` | `shouldRenderInPass(int pass)`
    `boolean` | `shouldRiderSit()` Used in model rendering to determine if the entity riding this entity should be in the 'sitting' position.
    `String` | `toString()`
    `void` | `travelToDimension(int par1)` Teleports the entity to another dimension.
    `void` | `updateRidden()` Handles updating while being ridden by an entity
    `void` | `updateRiderPosition()`
    `boolean` | `writeMountToNBT(NBTTagCompound par1NBTTagCompound)` Like writeToNBTOptional but does not check if the entity is ridden.
    `void` | `writeToNBT(NBTTagCompound par1NBTTagCompound)` Save the entity to NBT (calls an abstract helper method to write extra data)
    `boolean` | `writeToNBTOptional(NBTTagCompound par1NBTTagCompound)` Either write this entity to the NBT tag given and return true, or return false without doing anything.

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### entityId

          public int entityId

    - #### renderDistanceWeight

          public double renderDistanceWeight

    - #### preventEntitySpawning

          public boolean preventEntitySpawning

      Blocks entities from spawning when they do their AABB check to make sure the spot is clear of entities that can prevent spawning.

    - #### riddenByEntity

          public Entity riddenByEntity

      The entity that is riding this entity

    - #### ridingEntity

          public Entity ridingEntity

      The entity we are currently riding

    - #### forceSpawn

          public boolean forceSpawn

    - #### worldObj

          public World worldObj

      Reference to the World object.

    - #### prevPosX

          public double prevPosX

    - #### prevPosY

          public double prevPosY

    - #### prevPosZ

          public double prevPosZ

    - #### posX

          public double posX

      Entity position X

    - #### posY

          public double posY

      Entity position Y

    - #### posZ

          public double posZ

      Entity position Z

    - #### motionX

          public double motionX

      Entity motion X

    - #### motionY

          public double motionY

      Entity motion Y

    - #### motionZ

          public double motionZ

      Entity motion Z

    - #### rotationYaw

          public float rotationYaw

      Entity rotation Yaw

    - #### rotationPitch

          public float rotationPitch

      Entity rotation Pitch

    - #### prevRotationYaw

          public float prevRotationYaw

    - #### prevRotationPitch

          public float prevRotationPitch

    - #### boundingBox

          public final AxisAlignedBB boundingBox

      Axis aligned bounding box.

    - #### onGround

          public boolean onGround

    - #### isCollidedHorizontally

          public boolean isCollidedHorizontally

      True if after a move this entity has collided with something on X- or Z-axis

    - #### isCollidedVertically

          public boolean isCollidedVertically

      True if after a move this entity has collided with something on Y-axis

    - #### isCollided

          public boolean isCollided

      True if after a move this entity has collided with something either vertically or horizontally

    - #### velocityChanged

          public boolean velocityChanged

    - #### field_70135_K

          public boolean field_70135_K

    - #### isDead

          public boolean isDead

      Gets set by setDead, so this must be the flag whether an Entity is dead (inactive may be better term)

    - #### yOffset

          public float yOffset

    - #### width

          public float width

      How wide this entity is considered to be

    - #### height

          public float height

      How high this entity is considered to be

    - #### prevDistanceWalkedModified

          public float prevDistanceWalkedModified

      The previous ticks distance walked multiplied by 0.6

    - #### distanceWalkedModified

          public float distanceWalkedModified

      The distance walked multiplied by 0.6

    - #### distanceWalkedOnStepModified

          public float distanceWalkedOnStepModified

    - #### fallDistance

          public float fallDistance

    - #### lastTickPosX

          public double lastTickPosX

      The entity's X coordinate at the previous tick, used to calculate position during rendering routines

    - #### lastTickPosY

          public double lastTickPosY

      The entity's Y coordinate at the previous tick, used to calculate position during rendering routines

    - #### lastTickPosZ

          public double lastTickPosZ

      The entity's Z coordinate at the previous tick, used to calculate position during rendering routines

    - #### ySize

          public float ySize

    - #### stepHeight

          public float stepHeight

      How high this entity can step up when running into a block to try to get over it (currently make note the entity will always step up this amount and not just the amount needed)

    - #### noClip

          public boolean noClip

      Whether this entity won't clip with collision or not (make note it won't disable gravity)

    - #### entityCollisionReduction

          public float entityCollisionReduction

      Reduces the velocity applied by entity collisions by the specified percent.

    - #### ticksExisted

          public int ticksExisted

      How many ticks has this entity had ran since being alive

    - #### fireResistance

          public int fireResistance

      The amount of ticks you have to stand inside of fire before be set on fire

    - #### hurtResistantTime

          public int hurtResistantTime

      Remaining time an entity will be "immune" to further damage after being hurt.

    - #### addedToChunk

          public boolean addedToChunk

      Has this entity been added to the chunk its within

    - #### chunkCoordX

          public int chunkCoordX

    - #### chunkCoordY

          public int chunkCoordY

    - #### chunkCoordZ

          public int chunkCoordZ

    - #### serverPosX

          public int serverPosX

    - #### serverPosY

          public int serverPosY

    - #### serverPosZ

          public int serverPosZ

    - #### ignoreFrustumCheck

          public boolean ignoreFrustumCheck

      Render entity even if it is outside the camera frustum. Only true in EntityFish for now. Used in RenderGlobal: render if ignoreFrustumCheck or in frustum.

    - #### isAirBorne

          public boolean isAirBorne

    - #### timeUntilPortal

          public int timeUntilPortal

    - #### dimension

          public int dimension

      Which dimension the player is in (-1 = the Nether, 0 = normal world)

    - #### myEntitySize

          public EnumEntitySize myEntitySize

    - #### captureDrops

          public boolean captureDrops

    - #### capturedDrops

          public ArrayList<EntityItem> capturedDrops

  - ### Constructor Detail

    - #### Entity

          public Entity(World par1World)

  - ### Method Detail

    - #### getDataWatcher

          public DataWatcher getDataWatcher()

    - #### equals

          public boolean equals(Object par1Obj)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### setDead

          public void setDead()

      Will get destroyed next tick.

    - #### setPosition

          public void setPosition(double par1,
                         double par3,
                         double par5)

      Sets the x,y,z of the entity from the given parameters. Also seems to set up a bounding box.

    - #### setAngles

          public void setAngles(float par1,
                       float par2)

    - #### onUpdate

          public void onUpdate()

      Called to update the entity's position/logic.

    - #### onEntityUpdate

          public void onEntityUpdate()

      Gets called every tick from main Entity class

    - #### getMaxInPortalTime

          public int getMaxInPortalTime()

      Return the amount of time this entity should stay in a portal before being transported.

    - #### setFire

          public void setFire(int par1)

      Sets entity to burn for x amount of seconds, cannot lower amount of existing fire.

    - #### extinguish

          public void extinguish()

      Removes fire from entity.

    - #### isOffsetPositionInLiquid

          public boolean isOffsetPositionInLiquid(double par1,
                                         double par3,
                                         double par5)

      Checks if the offset position from the entity's current position is inside of liquid. Args: x, y, z

    - #### moveEntity

          public void moveEntity(double par1,
                        double par3,
                        double par5)

      Tries to moves the entity by the passed in displacement. Args: x, y, z

    - #### playSound

          public void playSound(String par1Str,
                       float par2,
                       float par3)

    - #### getBoundingBox

          public AxisAlignedBB getBoundingBox()

      returns the bounding box for this entity

    - #### isImmuneToFire

          public final boolean isImmuneToFire()

    - #### isWet

          public boolean isWet()

      Checks if this entity is either in water or on an open air block in rain (used in wolves).

    - #### isInWater

          public boolean isInWater()

      Checks if this entity is inside water (if inWater field is true as a result of handleWaterMovement() returning true)

    - #### handleWaterMovement

          public boolean handleWaterMovement()

      Returns if this entity is in water and will end up adding the waters velocity to the entity

    - #### isInsideOfMaterial

          public boolean isInsideOfMaterial(Material par1Material)

      Checks if the current block the entity is within of the specified material type

    - #### getEyeHeight

          public float getEyeHeight()

    - #### handleLavaMovement

          public boolean handleLavaMovement()

      Whether or not the current entity is in lava

    - #### moveFlying

          public void moveFlying(float par1,
                        float par2,
                        float par3)

      Used in both water and by flying objects

    - #### getBrightnessForRender

          public int getBrightnessForRender(float par1)

    - #### getBrightness

          public float getBrightness(float par1)

      Gets how bright this entity is.

    - #### setWorld

          public void setWorld(World par1World)

      Sets the reference to the World object.

    - #### setPositionAndRotation

          public void setPositionAndRotation(double par1,
                                    double par3,
                                    double par5,
                                    float par7,
                                    float par8)

      Sets the entity's position and rotation. Args: posX, posY, posZ, yaw, pitch

    - #### setLocationAndAngles

          public void setLocationAndAngles(double par1,
                                  double par3,
                                  double par5,
                                  float par7,
                                  float par8)

      Sets the location and Yaw/Pitch of an entity in the world

    - #### getDistanceToEntity

          public float getDistanceToEntity(Entity par1Entity)

      Returns the distance to the entity. Args: entity

    - #### getDistanceSq

          public double getDistanceSq(double par1,
                             double par3,
                             double par5)

      Gets the squared distance to the position. Args: x, y, z

    - #### getDistance

          public double getDistance(double par1,
                           double par3,
                           double par5)

      Gets the distance to the position. Args: x, y, z

    - #### getDistanceSqToEntity

          public double getDistanceSqToEntity(Entity par1Entity)

      Returns the squared distance to the entity. Args: entity

    - #### onCollideWithPlayer

          public void onCollideWithPlayer(EntityPlayer par1EntityPlayer)

      Called by a player entity when they collide with an entity

    - #### applyEntityCollision

          public void applyEntityCollision(Entity par1Entity)

      Applies a velocity to each of the entities pushing them away from each other. Args: entity

    - #### addVelocity

          public void addVelocity(double par1,
                         double par3,
                         double par5)

      Adds to the current velocity of the entity. Args: x, y, z

    - #### attackEntityFrom

          public boolean attackEntityFrom(DamageSource par1DamageSource,
                                 float par2)

      Called when the entity is attacked.

    - #### canBeCollidedWith

          public boolean canBeCollidedWith()

      Returns true if other Entities should be prevented from moving through this Entity.

    - #### canBePushed

          public boolean canBePushed()

      Returns true if this entity should push and be pushed by other entities when colliding.

    - #### addToPlayerScore

          public void addToPlayerScore(Entity par1Entity,
                              int par2)

      Adds a value to the player score. Currently not actually used and the entity passed in does nothing. Args: entity, scoreToAdd

    - #### isInRangeToRenderVec3D

          public boolean isInRangeToRenderVec3D(Vec3 par1Vec3)

    - #### isInRangeToRenderDist

          public boolean isInRangeToRenderDist(double par1)

    - #### writeMountToNBT

          public boolean writeMountToNBT(NBTTagCompound par1NBTTagCompound)

      Like writeToNBTOptional but does not check if the entity is ridden. Used for saving ridden entities with their riders.

    - #### writeToNBTOptional

          public boolean writeToNBTOptional(NBTTagCompound par1NBTTagCompound)

      Either write this entity to the NBT tag given and return true, or return false without doing anything. If this returns false the entity is not saved on disk. Ridden entities return false here as they are saved with their rider.

    - #### writeToNBT

          public void writeToNBT(NBTTagCompound par1NBTTagCompound)

      Save the entity to NBT (calls an abstract helper method to write extra data)

    - #### readFromNBT

          public void readFromNBT(NBTTagCompound par1NBTTagCompound)

      Reads the entity from NBT (calls an abstract helper method to read specialized data)

    - #### onChunkLoad

          public void onChunkLoad()

    - #### getShadowSize

          public float getShadowSize()

    - #### dropItem

          public EntityItem dropItem(int par1,
                            int par2)

      Drops an item stack at the entity's position. Args: itemID, count

    - #### dropItemWithOffset

          public EntityItem dropItemWithOffset(int par1,
                                      int par2,
                                      float par3)

      Drops an item stack with a specified y offset. Args: itemID, count, yOffset

    - #### entityDropItem

          public EntityItem entityDropItem(ItemStack par1ItemStack,
                                  float par2)

      Drops an item at the position of the entity.

    - #### isEntityAlive

          public boolean isEntityAlive()

      Checks whether target entity is alive.

    - #### isEntityInsideOpaqueBlock

          public boolean isEntityInsideOpaqueBlock()

      Checks if this entity is inside of an opaque block

    - #### interactFirst

          public boolean interactFirst(EntityPlayer par1EntityPlayer)

      First layer of player interaction

    - #### getCollisionBox

          public AxisAlignedBB getCollisionBox(Entity par1Entity)

      Returns a boundingBox used to collide the entity with other entities and blocks. This enables the entity to be pushable on contact, like boats or minecarts.

    - #### updateRidden

          public void updateRidden()

      Handles updating while being ridden by an entity

    - #### updateRiderPosition

          public void updateRiderPosition()

    - #### getYOffset

          public double getYOffset()

      Returns the Y Offset of this entity.

    - #### getMountedYOffset

          public double getMountedYOffset()

      Returns the Y offset from the entity's position for any entity riding this one.

    - #### mountEntity

          public void mountEntity(Entity par1Entity)

      Called when a player mounts an entity. e.g. mounts a pig, mounts a boat.

    - #### setPositionAndRotation2

          public void setPositionAndRotation2(double par1,
                                     double par3,
                                     double par5,
                                     float par7,
                                     float par8,
                                     int par9)

    - #### getCollisionBorderSize

          public float getCollisionBorderSize()

    - #### getLookVec

          public Vec3 getLookVec()

      returns a (normalized) vector of where this entity is looking

    - #### setInPortal

          public void setInPortal()

      Called by portal blocks when an entity is within it.

    - #### getPortalCooldown

          public int getPortalCooldown()

      Return the amount of cooldown before this entity can use a portal again.

    - #### setVelocity

          public void setVelocity(double par1,
                         double par3,
                         double par5)

    - #### handleHealthUpdate

          public void handleHealthUpdate(byte par1)

    - #### performHurtAnimation

          public void performHurtAnimation()

    - #### getLastActiveItems

          public ItemStack[] getLastActiveItems()

    - #### setCurrentItemOrArmor

          public void setCurrentItemOrArmor(int par1,
                                   ItemStack par2ItemStack)

      Sets the held item, or an armor slot. Slot 0 is held item. Slot 1-4 is armor. Params: Item, slot

    - #### isBurning

          public boolean isBurning()

      Returns true if the entity is on fire. Used by render to add the fire effect on rendering.

    - #### isRiding

          public boolean isRiding()

      Returns true if the entity is riding another entity, used by render to rotate the legs to be in 'sit' position for players.

    - #### isSneaking

          public boolean isSneaking()

      Returns if this entity is sneaking.

    - #### setSneaking

          public void setSneaking(boolean par1)

      Sets the sneaking flag.

    - #### isSprinting

          public boolean isSprinting()

      Get if the Entity is sprinting.

    - #### setSprinting

          public void setSprinting(boolean par1)

      Set sprinting switch for Entity.

    - #### isInvisible

          public boolean isInvisible()

    - #### isInvisibleToPlayer

          public boolean isInvisibleToPlayer(EntityPlayer par1EntityPlayer)

    - #### setInvisible

          public void setInvisible(boolean par1)

    - #### isEating

          public boolean isEating()

    - #### setEating

          public void setEating(boolean par1)

    - #### getAir

          public int getAir()

    - #### setAir

          public void setAir(int par1)

    - #### onStruckByLightning

          public void onStruckByLightning(EntityLightningBolt par1EntityLightningBolt)

      Called when a lightning bolt hits the entity.

    - #### onKillEntity

          public void onKillEntity(EntityLivingBase par1EntityLivingBase)

      This method gets called when the entity kills another one.

    - #### setInWeb

          public void setInWeb()

      Sets the Entity inside a web block.

    - #### getEntityName

          public String getEntityName()

      Gets the username of the entity.

    - #### getParts

          public Entity[] getParts()

      Return the Entity parts making up this Entity (currently only for dragons)

    - #### isEntityEqual

          public boolean isEntityEqual(Entity par1Entity)

      Returns true if Entity argument is equal to this Entity

    - #### getRotationYawHead

          public float getRotationYawHead()

    - #### setRotationYawHead

          public void setRotationYawHead(float par1)

    - #### canAttackWithItem

          public boolean canAttackWithItem()

      If returns false, the item will not inflict any damage against entities.

    - #### hitByEntity

          public boolean hitByEntity(Entity par1Entity)

      Called when a player attacks an entity. If this returns true the attack will not happen.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### isEntityInvulnerable

          public boolean isEntityInvulnerable()

      Return whether this entity is invulnerable to damage.

    - #### copyLocationAndAnglesFrom

          public void copyLocationAndAnglesFrom(Entity par1Entity)

      Sets this entity's location and angles to the location and angles of the passed in entity.

    - #### copyDataFrom

          public void copyDataFrom(Entity par1Entity,
                          boolean par2)

      Copies important data from another entity to this entity. Used when teleporting entities between worlds, as this actually deletes the teleporting entity and re-creates it on the other side. Params: Entity to copy from, unused (always true)

    - #### travelToDimension

          public void travelToDimension(int par1)

      Teleports the entity to another dimension. Params: Dimension number to teleport to

    - #### getBlockExplosionResistance

          public float getBlockExplosionResistance(Explosion par1Explosion,
                                          World par2World,
                                          int par3,
                                          int par4,
                                          int par5,
                                          Block par6Block)

      Gets a block's resistance to this entity's explosion. Used to make rails immune to TNT minecarts' explosions and Wither skulls more destructive.

    - #### shouldExplodeBlock

          public boolean shouldExplodeBlock(Explosion par1Explosion,
                                   World par2World,
                                   int par3,
                                   int par4,
                                   int par5,
                                   int par6,
                                   float par7)

    - #### getMaxSafePointTries

          public int getMaxSafePointTries()

      The number of iterations PathFinder.getSafePoint will execute before giving up.

    - #### getTeleportDirection

          public int getTeleportDirection()

    - #### doesEntityNotTriggerPressurePlate

          public boolean doesEntityNotTriggerPressurePlate()

      Return whether this entity should NOT trigger a pressure plate or a tripwire.

    - #### addEntityCrashInfo

          public void addEntityCrashInfo(CrashReportCategory par1CrashReportCategory)

    - #### canRenderOnFire

          public boolean canRenderOnFire()

    - #### getUniqueID

          public UUID getUniqueID()

    - #### isPushedByWater

          public boolean isPushedByWater()

    - #### getTranslatedEntityName

          public String getTranslatedEntityName()

      Returns the translated name of the entity.

    - #### getEntityData

          public NBTTagCompound getEntityData()

      Returns a NBTTagCompound that can be used to store custom data for this entity. It will be written, and read from disc, so it persists over world saves.
      Returns:
        A NBTTagCompound

    - #### shouldRiderSit

          public boolean shouldRiderSit()

      Used in model rendering to determine if the entity riding this entity should be in the 'sitting' position.
      Returns:
        false to prevent an entity that is mounted to this entity from displaying the 'sitting' animation.

    - #### getPickedResult

          public ItemStack getPickedResult(MovingObjectPosition target)

      Called when a user uses the creative pick block button on this entity.
      Parameters:
        `target` - The full target the player is looking at
      Returns:
        A ItemStack to add to the player's inventory, Null if nothing should be added.

    - #### getPersistentID

          public UUID getPersistentID()

    - #### resetEntityId

          public final void resetEntityId()

      Reset the entity ID to a new value. Not to be used from Mod code

    - #### shouldRenderInPass

          public boolean shouldRenderInPass(int pass)

    - #### isCreatureType

          public boolean isCreatureType(EnumCreatureType type,
                               boolean forSpawnCount)

      Returns true if the entity is of the @link{EnumCreatureType} provided
      Parameters:
        `type` - The EnumCreatureType type this entity is evaluating
        `forSpawnCount` - If this is being invoked to check spawn count caps.
      Returns:
        If the creature is of the type provided

    - #### registerExtendedProperties

          public String registerExtendedProperties(String identifier,
                                          IExtendedEntityProperties properties)

      Register the instance of IExtendedProperties into the entity's collection.
      Parameters:
        `identifier` - The identifier which you can use to retrieve these properties for the entity.
        `properties` - The instanceof IExtendedProperties to register
      Returns:
        The identifier that was used to register the extended properties. Empty String indicates an error. If your requested key already existed, this will return a modified one that is unique.

    - #### getExtendedProperties

          public IExtendedEntityProperties getExtendedProperties(String identifier)

      Gets the extended properties identified by the passed in key
      Parameters:
        `identifier` - The key that identifies the extended properties.
      Returns:
        The instance of IExtendedProperties that was found, or null.

    - #### canRiderInteract

          public boolean canRiderInteract()

      If a rider of this entity can interact with this entity. Should return true on the ridden entity if so.
      Returns:
        if the entity can be interacted with from a rider

    - #### shouldDismountInWater

          public boolean shouldDismountInWater(Entity rider)

      If the rider should be dismounted from the entity when the entity goes under water
      Parameters:
        `rider` - The entity that is riding
      Returns:
        if the entity should be dismounted when under water